Tp::CallContent Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Signals | Public Member Functions | List of all members
Tp::CallContent Class Reference
Channel proxies

The CallContent class provides an object representing a Telepathy Call.Content. More...

`#include <TelepathyQt/CallContent>`

Inherits Tp::StatefulDBusProxy, and Tp::OptionalInterfaceFactory< CallContent >.

## Signals
void | streamAdded (const Tp::CallStreamPtr &stream)
void | streamRemoved (const Tp::CallStreamPtr &stream, const Tp::CallStateReason &reason)
Signals inherited from Tp::DBusProxy
void | invalidated (Tp::DBusProxy *proxy, const QString &errorName, const QString &errorMessage)
Signals inherited from Tp::Object
void | propertyChanged (const QString &propertyName)

## Public Member Functions
| ~CallContent ()
CallChannelPtr | channel () const
QString | name () const
MediaStreamType | type () const
CallContentDisposition | disposition () const
CallStreams | streams () const
PendingOperation * | remove ()
bool | supportsDTMF () const
PendingOperation * | startDTMFTone (DTMFEvent event)
PendingOperation * | stopDTMFTone ()
Public Member Functions inherited from Tp::StatefulDBusProxy
| StatefulDBusProxy (const QDBusConnection &dbusConnection, const QString &busName, const QString &objectPath, const Feature &featureCore)
virtual | ~StatefulDBusProxy ()
Public Member Functions inherited from Tp::DBusProxy
| DBusProxy (const QDBusConnection &dbusConnection, const QString &busName, const QString &objectPath, const Feature &featureCore)
virtual | ~DBusProxy ()
QDBusConnection | dbusConnection () const
QString | busName () const
QString | objectPath () const
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
Public Member Functions inherited from Tp::Object
virtual | ~Object ()
Public Member Functions inherited from Tp::RefCounted
| RefCounted ()
virtual | ~RefCounted ()
Public Member Functions inherited from Tp::ReadyObject
| ReadyObject (RefCounted *object, const Feature &featureCore)
| ReadyObject (DBusProxy *proxy, const Feature &featureCore)
virtual | ~ReadyObject ()
virtual bool | isReady (const Features &features=Features()) const
virtual PendingReady * | becomeReady (const Features &requestedFeatures=Features())
virtual Features | requestedFeatures () const
virtual Features | actualFeatures () const
virtual Features | missingFeatures () const
Public Member Functions inherited from Tp::OptionalInterfaceFactory< CallContent >
| OptionalInterfaceFactory (CallContent *this_)
| ~OptionalInterfaceFactory ()
QStringList | interfaces () const
bool | hasInterface (const QString &name) const
Interface * | optionalInterface (InterfaceSupportedChecking check=CheckInterfaceSupported) const
Interface * | interface () const

## Additional Inherited Members
Public Types inherited from Tp::OptionalInterfaceFactory< CallContent >
enum | InterfaceSupportedChecking
Static Public Member Functions inherited from Tp::StatefulDBusProxy
static QString | uniqueNameFrom (const QDBusConnection &bus, const QString &wellKnownOrUnique)
static QString | uniqueNameFrom (const QDBusConnection &bus, const QString &wellKnownOrUnique, QString &error, QString &message)
Protected Member Functions inherited from Tp::DBusProxy
void | setBusName (const QString &busName)
void | invalidate (const QString &reason, const QString &message)
void | invalidate (const QDBusError &error)
Protected Member Functions inherited from Tp::Object
| Object ()
void | notify (const char *propertyName)
Protected Member Functions inherited from Tp::ReadyObject
ReadinessHelper * | readinessHelper () const
Protected Member Functions inherited from Tp::OptionalInterfaceFactory< CallContent >
void | setInterfaces (const QStringList &interfaces)

## Detailed Description

The CallContent class provides an object representing a Telepathy Call.Content.

Instances of this class cannot be constructed directly; the only way to get one is via CallChannel.

See Asynchronous Object Model

## Constructor & Destructor Documentation

Tp::CallContent::~CallContent | ( |  | ) |

Class destructor.

## Member Function Documentation

CallChannelPtr Tp::CallContent::channel | ( |  | ) | const

Return the channel owning this media content.

Returns
  The channel owning this media content.

QString Tp::CallContent::name | ( |  | ) | const

Return the name of this media content.

Returns
  The name of this media content.

MediaStreamType Tp::CallContent::type | ( |  | ) | const

Return the type of this media content.

Returns
  The type of this media content.

CallContentDisposition Tp::CallContent::disposition | ( |  | ) | const

Return the disposition of this media content.

Returns
  The disposition of this media content.

CallStreams Tp::CallContent::streams | ( |  | ) | const

Return the media streams of this media content.

Returns
  A list of media streams of this media content.

See Also
  streamAdded(), streamRemoved()

PendingOperation * Tp::CallContent::remove | ( |  | ) |

Removes this media content from the call.

Returns
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

bool Tp::CallContent::supportsDTMF | ( |  | ) | const

Return whether sending DTMF events is supported on this content. DTMF is only supported on audio contents that implement the TP_QT_IFACE_CALL_CONTENT_INTERFACE_DTMF interface.

Returns
  `true` if DTMF is supported, or `false` otherwise.

PendingOperation * Tp::CallContent::startDTMFTone | ( | DTMFEvent | event | ) |

Start sending a DTMF tone on this media stream.

Where possible, the tone will continue until stopDTMFTone() is called. On certain protocols, it may only be possible to send events with a predetermined length. In this case, the implementation may emit a fixed-length tone, and the stopDTMFTone() method call should return TP_QT_ERROR_NOT_AVAILABLE.

If this content does not support the TP_QT_IFACE_CALL_CONTENT_INTERFACE_DTMF interface, the resulting PendingOperation will fail with error code TP_QT_ERROR_NOT_IMPLEMENTED.

Parameters

  event | A numeric event code from the DTMFEvent enum.

Returns
  A PendingOperation which will emit PendingOperation::finished when the request finishes.

See Also
  stopDTMFTone(), supportsDTMF()

PendingOperation * Tp::CallContent::stopDTMFTone | ( |  | ) |

Stop sending any DTMF tone which has been started using the startDTMFTone() method.

If there is no current tone, the resulting PendingOperation will finish successfully.

If this content does not support the TP_QT_IFACE_CALL_CONTENT_INTERFACE_DTMF interface, the resulting PendingOperation will fail with error code TP_QT_ERROR_NOT_IMPLEMENTED.

Returns
  A PendingOperation which will emit PendingOperation::finished when the request finishes.

See Also
  startDTMFTone(), supportsDTMF()

void Tp::CallContent::streamAdded | ( | const Tp::CallStreamPtr & | stream | ) |
| signal

This signal is emitted when a new media stream is added to this media content.

Parameters

  stream | The media stream that was added.

See Also
  streams()

void Tp::CallContent::streamRemoved | ( | const Tp::CallStreamPtr & | stream,
|  | const Tp::CallStateReason & | reason
| ) |  |
| signal

This signal is emitted when a new media stream is removed from this media content.

Parameters

  stream | The media stream that was removed.
  reason | The reason for this removal.

See Also
  streams()